
/*  File dump7ck.c
 created ven. déc. 17 09:26:19 CET 2021

 This filter dumps the contents of a p7k file
 and displays it in ASCII/decimal to stdout.

  gcc -Os -Wall dump7ck.c -o dump7ck
*/

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "p7ck.c"

const uint64_t msk = 0x8080808080808080ULL;

int main(int argc, char *argv[]) {
  p7k_struct p;
  uint32_t a, b, c;
  uint64_t d;
  ssize_t i;
  int f=STDIN_FILENO;

  if (argc == 2) {
    f=open(argv[1], O_RDONLY);
    if (f == -1) {
      perror("can't open output file for writing");
      return EXIT_FAILURE;
    }
    fprintf (stderr, "opened %s\n", argv[1]);
  }

  do {
    i=read(f, &p, sizeof p);
    if ((i != sizeof p)
      | (p.z != 0)
      | (((*(uint64_t*)&p)   & msk) != msk)
      | (((*(uint64_t*)&p+1) & msk) != msk)
      | (((*(uint64_t*)&p+2) & msk) != msk))
      return EXIT_SUCCESS;
    decode_p7k( &a, &b, &c, &d, &p);
    printf("%u %u %u %"PRIu64"\n", a, b, c, d);
  } while (1);
}
